package api

import (
	"sku3dweb/db/model"
	"sku3dweb/db/repo"
	"time"

	"github.com/gin-gonic/gin"
)

func CreateBackgroundRouter(router *GinRouter) {

	//创建贴图操作
	CreateCRUD(router, "/background", &CRUDOption{
		Collection: repo.CollectionBackground,
		NewModel: func(c *gin.Context) interface{} {

			body := &struct {
				Type int32
			}{}
			c.ShouldBindJSON(&body)

			return &model.CanvasBackground{
				Type:       body.Type,
				Order:      0,
				Color:      &model.Vect3{0.749, 0.749, 0.749},
				Image:      &model.OssType{Url: "", Size: 0},
				CreateTime: time.Now(),
			}
		},
		EmtyModel: func(*gin.Context) interface{} {
			return &model.CanvasBackground{}
		},
		SearchProject: []string{"image", "createTime", "type", "order", "color"},
	})
}
