package api

import (
	"sku3dweb/db/model"
	"sku3dweb/db/repo"
	"time"

	"github.com/gin-gonic/gin"
)

func CreateCatRouter(router *GinRouter) {

	//分类操作
	CreateCRUD(router, "/category", &CRUDOption{
		Collection: repo.CollectionCategory,
		NewModel: func(c *gin.Context) interface{} {
			cat := &model.Category{
				CreateTime: time.Now(),
			}
			c.ShouldBindJSON(cat)
			return cat
		},
		EmtyModel: func(*gin.Context) interface{} {
			return &model.Category{}
		},
		SearchProject: []string{"name", "type", "children", "createTime"},
	})

	// router.GET("/qiye/res/category/list", func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
	// 	_, _, query := UtilQueryPageSize(c)

	// 	body := &struct {
	// 		Id string
	// 	}{Id: query["id"].(string)}
	// 	if len(body.Id) < 1 {
	// 		return nil, NewError("id不能为空")
	// 	}

	// 	options := &repo.DocsSearchOptions{CollectName: repo.CollectionLibCategory, Query: repo.Map{"userId": body.Id}}
	// 	options.Project = []string{"name", "type", "parent", "createTime", "type", "value", "level", "orderId"}
	// 	_, list := repo.RepoSeachDocsMap(apictx.CreateRepoCtx(), options)
	// 	return map[string]interface{}{"list": list, "total": len(list), "page": 1, "size": len(list)}, nil
	// })

	// router.GET("/qiye/lib/category/list", func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
	// 	_, _, query := UtilQueryPageSize(c)

	// 	body := &struct {
	// 		Id string
	// 	}{Id: query["id"].(string)}

	// 	if len(body.Id) < 1 {
	// 		return nil, NewError("id不能为空")
	// 	}
	// 	options := &repo.DocsSearchOptions{CollectName: repo.CollectionLib2Category, Query: repo.Map{"userId": body.Id}}
	// 	options.Project = []string{"categoryIds", "type"}
	// 	_, list := repo.RepoSeachDocsMap(apictx.CreateRepoCtx(), options)

	// 	return map[string]interface{}{"list": list, "total": len(list), "page": 1, "size": len(list)}, nil
	// })

	// router.GET("/platform/res/category/list", func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
	// 	options := &repo.DocsSearchOptions{CollectName: repo.CollectionLibCategory, Query: repo.Map{"userId": PLATFORM_USER_ID}}
	// 	options.Project = []string{"name", "type", "parent", "createTime", "type", "value", "level", "orderId"}
	// 	_, list := repo.RepoSeachDocsMap(apictx.CreateRepoCtx(), options)
	// 	return map[string]interface{}{"list": list, "total": len(list), "page": 1, "size": len(list)}, nil
	// })

	// router.GET("/dadong/res/category/list", func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
	// 	options := &repo.DocsSearchOptions{CollectName: repo.CollectionLibCategory, Query: repo.Map{"userId": DADONG_USER_ID}}
	// 	options.Project = []string{"name", "type", "parent", "createTime", "type", "value", "level", "orderId"}
	// 	_, list := repo.RepoSeachDocsMap(apictx.CreateRepoCtx(), options)
	// 	return map[string]interface{}{"list": list, "total": len(list), "page": 1, "size": len(list)}, nil
	// })

	// router.GET("/platform/lib/category/list", func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
	// 	options := &repo.DocsSearchOptions{CollectName: repo.CollectionLib2Category, Query: repo.Map{"userId": PLATFORM_USER_ID}}
	// 	options.Project = []string{"categoryIds", "type"}
	// 	_, list := repo.RepoSeachDocsMap(apictx.CreateRepoCtx(), options)
	// 	return map[string]interface{}{"list": list, "total": len(list), "page": 1, "size": len(list)}, nil
	// })

	// router.GET("/dadong/lib/category/list", func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
	// 	options := &repo.DocsSearchOptions{CollectName: repo.CollectionLib2Category, Query: repo.Map{"userId": DADONG_USER_ID}}
	// 	options.Project = []string{"categoryIds", "type"}
	// 	_, list := repo.RepoSeachDocsMap(apictx.CreateRepoCtx(), options)
	// 	return map[string]interface{}{"list": list, "total": len(list), "page": 1, "size": len(list)}, nil
	// })

	// CreateCRUD(router, "/res/category", &CRUDOption{
	// 	Collection: repo.CollectionLibCategory,
	// 	NewModel2: func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
	// 		cat := &model.ResCategory{}
	// 		c.ShouldBindJSON(cat)
	// 		cat.UserId = apictx.User.Parent
	// 		cat.CreateTime = time.Now()
	// 		return cat, nil
	// 	},

	// 	EmtyModel: func(*gin.Context) interface{} {
	// 		return &model.ResCategory{}
	// 	},
	// 	JWT: true,
	// 	SearchFilter: func(c *gin.Context, apictx *ApiSession, query map[string]interface{}) map[string]interface{} {
	// 		return map[string]interface{}{"userId": apictx.User.Parent}
	// 	},

	// 	SearchProject: []string{"name", "type", "parent", "createTime", "type", "value", "level", "orderId"},

	// 	Remove: func(c *gin.Context, apictx *ApiSession, id string) (interface{}, error) {
	// 		team := &model.ResCategory{}

	// 		ok, _ := repo.RepoSeachDoc(apictx.CreateRepoCtx(), &repo.DocSearchOptions{CollectName: repo.CollectionLibCategory, Query: repo.Map{"_id": id}, Project: []string{"orderId", "type"}}, team)

	// 		if !ok {
	// 			return nil, NewError("删除失败!")
	// 		}

	// 		minOrderId := team.OrderId //后面有几个零
	// 		if minOrderId > 0 {
	// 			var maxStep int64 = 1
	// 			currValue := minOrderId
	// 			for {
	// 				if currValue%10 == 0 {
	// 					currValue = currValue / 10
	// 					maxStep = maxStep * 10
	// 				} else {
	// 					break
	// 				}
	// 			}
	// 			maxOrderId := minOrderId + maxStep - 1
	// 			return repo.RepoDeleteDocs(apictx.CreateRepoCtx(), repo.CollectionLibCategory, &bson.M{"orderId": bson.M{"$gte": minOrderId, "$lt": maxOrderId}, "type": team.Type})
	// 		}

	// 		return repo.RepoDeleteDoc(apictx.CreateRepoCtx(), repo.CollectionLibCategory, id)
	// 	},
	// })

	// CreateCRUD(router, "/lib/category", &CRUDOption{
	// 	Collection: repo.CollectionLib2Category,
	// 	NewModel2: func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
	// 		cat := &model.LibCategory{}
	// 		c.ShouldBindJSON(cat)
	// 		cat.UserId = apictx.User.Parent
	// 		cat.CreateTime = time.Now()
	// 		return cat, nil
	// 	},

	// 	EmtyModel: func(*gin.Context) interface{} {
	// 		return &model.LibCategory{}
	// 	},
	// 	JWT: true,
	// 	SearchFilter: func(c *gin.Context, apictx *ApiSession, query map[string]interface{}) map[string]interface{} {
	// 		return map[string]interface{}{"userId": apictx.User.Parent}
	// 	},
	// 	SearchProject: []string{"type", "categoryIds", "createTime"},
	// })

	//team

	// CreateCRUD(router, "/team", &CRUDOption{
	// 	Collection: repo.CollectionLibCategory,
	// 	NewModel2: func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
	// 		cat := &model.Team{}
	// 		c.ShouldBindJSON(cat)
	// 		cat.UserId = apictx.User.Parent
	// 		cat.CreateTime = time.Now()
	// 		return cat, nil
	// 	},

	// 	EmtyModel: func(*gin.Context) interface{} {
	// 		return &model.Team{}
	// 	},
	// 	SearchFilter: func(c *gin.Context, apictx *ApiSession, query map[string]interface{}) map[string]interface{} {
	// 		return
	// 	},
	// 	SearchProject: []string{"name", "userCount", "filters", "createTime"},
	// })
}
