package comm

import "time"

type LiscenseActiveCode struct {
	Id       string `bson:"_id,omitempty" json:"_id"`
	AppName  string `bson:"appName,omitempty" json:"appName"`
	AppKey   string `bson:"appKey,omitempty" json:"appKey"`
	AuthId   string `bson:"authId,omitempty" json:"authId"`
	AuthName string `bson:"authName,omitempty" json:"authName"`

	CreateTime time.Time `bson:"createTime,omitempty" json:"createTime"`

	StartTime  time.Time     `bson:"startTime,omitempty" json:"startTime"`
	ExpireTime time.Time     `bson:"expireTime,omitempty" json:"expireTime"`
	Duration   time.Duration `bson:"duration,omitempty" json:"duration"`

	DeviceHashCode string `bson:"deviceHashCode,omitempty" json:"deviceHashCode"`
}

const (
	AuthStatusNoActive = "未激活"
	AuthStatusExpired  = "已过期"
	AuthStatusOK       = "已激活"
)

type AuthInfo struct {
	AuthName   string
	AuthId     string
	Duration   time.Duration
	Expired    time.Time
	CreateTime time.Time
	Status     string
}
