package model

import (
	"time"

	"go.mongodb.org/mongo-driver/bson/primitive"
)

type TeamHeelMesh struct {
	Id     primitive.ObjectID `bson:"_id,omitempty" json:"_id,omitempty"`
	TeamId primitive.ObjectID `bson:"teamId,omitempty" json:"teamId,omitempty"`
	FromId primitive.ObjectID `bson:"fromId,omitempty" json:"fromId,omitempty"`

	Name       string    `bson:"name,omitempty" json:"name,omitempty"`
	CreateTime time.Time `bson:"createTime,omitempty" json:"createTime,omitempty"`
	UpdateTime time.Time `bson:"updateTime,omitempty" json:"updateTime,omitempty"`
	Thumbnail  *OssType  `bson:"thumbnail,omitempty" json:"thumbnail,omitempty"`

	Categories []string `bson:"categories,omitempty" json:"categories,omitempty"` //所属分类Id

	Enable *bool             `bson:"enable,omitempty" json:"enable,omitempty"` //是否有效
	Source *StaticMeshSource `bson:"source,omitempty" json:"source,omitempty"`
}

type TeamLastMesh struct {
	Id     primitive.ObjectID `bson:"_id,omitempty" json:"_id,omitempty"`
	TeamId primitive.ObjectID `bson:"teamId,omitempty" json:"teamId,omitempty"`
	FromId primitive.ObjectID `bson:"fromId,omitempty" json:"fromId,omitempty"`

	Name       string    `bson:"name,omitempty" json:"name,omitempty"`
	CreateTime time.Time `bson:"createTime,omitempty" json:"createTime,omitempty"`
	UpdateTime time.Time `bson:"updateTime,omitempty" json:"updateTime,omitempty"`
	Thumbnail  *OssType  `bson:"thumbnail,omitempty" json:"thumbnail,omitempty"`

	Categories []string `bson:"categories,omitempty" json:"categories,omitempty"` //所属分类Id

	Enable *bool             `bson:"enable,omitempty" json:"enable,omitempty"` //是否有效
	Source *StaticMeshSource `bson:"source,omitempty" json:"source,omitempty"`
}

type TeamDecorateMesh struct {
	Id     primitive.ObjectID `bson:"_id,omitempty" json:"_id,omitempty"`
	TeamId primitive.ObjectID `bson:"teamId,omitempty" json:"teamId,omitempty"`
	FromId primitive.ObjectID `bson:"fromId,omitempty" json:"fromId,omitempty"`

	Name       string    `bson:"name,omitempty" json:"name,omitempty"`
	CreateTime time.Time `bson:"createTime,omitempty" json:"createTime,omitempty"`
	UpdateTime time.Time `bson:"updateTime,omitempty" json:"updateTime,omitempty"`
	Thumbnail  *OssType  `bson:"thumbnail,omitempty" json:"thumbnail,omitempty"`

	Categories []string `bson:"categories,omitempty" json:"categories,omitempty"` //所属分类Id

	Enable *bool             `bson:"enable,omitempty" json:"enable,omitempty"` //是否有效
	Source *StaticMeshSource `bson:"source,omitempty" json:"source,omitempty"`
}

type TeamSoleMesh struct {
	Id     primitive.ObjectID `bson:"_id,omitempty" json:"_id,omitempty"`
	TeamId primitive.ObjectID `bson:"teamId,omitempty" json:"teamId,omitempty"`
	FromId primitive.ObjectID `bson:"fromId,omitempty" json:"fromId,omitempty"`

	Name       string    `bson:"name,omitempty" json:"name,omitempty"`
	CreateTime time.Time `bson:"createTime,omitempty" json:"createTime,omitempty"`
	UpdateTime time.Time `bson:"updateTime,omitempty" json:"updateTime,omitempty"`
	Thumbnail  *OssType  `bson:"thumbnail,omitempty" json:"thumbnail,omitempty"`

	Categories []string `bson:"categories,omitempty" json:"categories,omitempty"` //所属分类Id

	Enable *bool             `bson:"enable,omitempty" json:"enable,omitempty"` //是否有效
	Source *StaticMeshSource `bson:"source,omitempty" json:"source,omitempty"`
}
