package repo

import (
	"sku3dweb/db/model"

	"sku3dweb/comm"

	"go.mongodb.org/mongo-driver/bson/primitive"
)

func MaterialGetById(ctx *RepoSession, id string, project []string) *model.Material {
	eid, _ := primitive.ObjectIDFromHex(id)
	option := DocSearchOptions{
		CollectName: CollectionMaterials,
		Query:       Map{"_id": eid},
		Project:     project,
	}
	entity := &model.Material{}
	ok, err := RepoSeachDoc(ctx, &option, entity)
	if err != nil || !ok {
		return nil
	}
	return entity
}

func SpecialMatGetById(ctx *RepoSession, id string) *comm.SpecialMat {

	eid, _ := primitive.ObjectIDFromHex(id)
	option := DocSearchOptions{
		CollectName: CollectionSpecialMaterials,
		Query:       Map{"_id": eid},
	}

	entity := &comm.SpecialMat{}
	ok, err := RepoSeachDoc(ctx, &option, entity)
	if err != nil || !ok {
		return nil
	}
	return entity
}
