package utils

import (
	"fmt"
	"log"
	"net/http"
	"net/http/httputil"
	"sku3dweb/conf"

	"github.com/gin-gonic/gin"
)

func OrderIdRange(OrderId int64) (int64, int64) {
	minOrderId := OrderId //后面有几个零
	var maxStep int64 = 1
	currValue := minOrderId
	for {
		if currValue%10 == 0 {
			currValue = currValue / 10
			maxStep = maxStep * 10
		} else {
			break
		}
	}
	maxOrderId := minOrderId + maxStep - 1
	return minOrderId, maxOrderId
}

func CreateServiceProxy(proxConf *conf.Proxy) gin.HandlerFunc {

	return func(c *gin.Context) {

		director := func(req *http.Request) {
			req.URL.Scheme = proxConf.Scheme
			req.URL.Host = proxConf.Host
			req.URL.Path = proxConf.Path + c.Param("action")
			// req.URL.Path, req.URL.RawPath = joinURLPath(target, req.URL)

			// if targetQuery == "" || req.URL.RawQuery == "" {
			// 	req.URL.RawQuery = targetQuery + req.URL.RawQuery
			// } else {
			// 	req.URL.RawQuery = targetQuery + "&" + req.URL.RawQuery
			// }
			if _, ok := req.Header["User-Agent"]; !ok {
				// explicitly disable User-Agent so it's not set to default value
				req.Header.Set("User-Agent", "")
			}
		}
		// proxy3 := httputil.NewSingleHostReverseProxy(u)
		proxy := &httputil.ReverseProxy{Director: director}

		//重写出错回调
		proxy.ErrorHandler = func(rw http.ResponseWriter, req *http.Request, err error) {
			log.Printf("http: proxy error: %v", err)
			ret := fmt.Sprintf("http proxy error %v", err)
			//写到body里
			rw.Write([]byte(ret))
		}
		proxy.ServeHTTP(c.Writer, c.Request)
	}
}
